<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset='utf-8'>
    <meta name='viewport' content='width=device-width, initial-scale=1'>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

</head>
<style>
    .picture-cover {
        background-image: url("LuckyDiceImagesv2023Feb/cover.jpg");
        height: 100px;
        margin: 5px;
    }
</style>

<body>
    <div class="container-fluid bg-warning picture-cover"></div>
    <div class="container">
        <div class="row  ">
            <div class="col-sm-5">
                <div class="row form-group">
                    <h3 class="text-primary">Nhập thông tin của bạn</h3>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="">UserName</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-username" class="form-control" type="text">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="">FirstName</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-firstname" class="form-control" type="text">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="">Lastname</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-lastname" class="form-control" type="text">
                    </div>
                </div>
            </div>
            <div class="col-sm-4">
                <div class="row text-center form-group">
                    <div class="col-sm-12">
                        <input onclick="onBtnDiceNewClick()" class="btn btn-success button-width w-75" type="button"
                            value="Ném">
                    </div>
                </div>
                <div class="row text-center form-group">
                    <div class="col-sm-12">
                        <img id="img-dice" class="img-thumbnail" src="LuckyDiceImagesv2023Feb/dice.png" alt="">
                    </div>
                </div>
                <div class="row text-center form-group">
                    <div class="col-sm-12">
                        <p id="p-dice">Chúc Mừng</p>
                    </div>
                </div>
            </div>
            <div class="col-sm-3">
                <div class="row text-center form-group">
                    <div class="col-sm-12">
                        <p>Voucher</p>
                        <p id="p-voucher">No ID</p>
                        <p id="p-%voucher">0%</p>

                    </div>
                </div>
                <div class="row text-center form-group">
                    <div class="col-sm-12">
                        <img id="img-prize" class="img-thumbnail" src="LuckyDiceImagesv2023Feb/xe-may.jpg" alt="">
                    </div>
                </div>
            </div>

        </div>
        <div class="row text-center form-group">
            <div class="col-sm-12">
                <button onclick="onBtnDiceHistory()" class="btn btn-success button-width w-25">Dice History</button>
                <button class="btn btn-success button-width w-25">Voucher History</button>
                <button class="btn btn-success button-width w-25">Present History</button>
            </div>
        </div>
        <div class="row">
            <div class="col-sm-12">
                <table id="history-placeholder-table" class="table table-striped table-hover border">

                    <tr>
                        <th>Lượt</th>
                        <th>Dice</th>
                    </tr>
                    <tr>
                        <td>1</td>
                        <td>2</td>

                    </tr>
                    <tr>
                        <td>1</td>
                        <td>2</td>

                    </tr>
                </table>
            </div>
        </div>
    </div>
</body>
<script>
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const vBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice/";
    const vUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";

    // hàm nút dice history
    function onBtnDiceHistory() {
        var vDiceHistory = {
            username: "",
            firstname: "",
            lastname: "",
        }
        readData(vDiceHistory);
        var isCheck = validateData(vDiceHistory);
        if (isCheck) {
            var vXmlHttpDiceHistory = new XMLHttpRequest();
            callApiDiceHistory(vDiceHistory, vXmlHttpDiceHistory)
            vXmlHttpDiceHistory.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    console.log(vXmlHttpDiceHistory.responseText);
                    showDatadiceHistory(vXmlHttpDiceHistory);
                }
            }
        }
    }
    // hàm ném xúc xác
    function onBtnDiceNewClick() {
        console.log("%c New Dice ", "color: blue")
        var vNewDice = {
            username: "",
            firstname: "",
            lastname: "",
        }
        readData(vNewDice);
        var isCheck = validateData(vNewDice);
        if (isCheck) {
            var vXmlHttpDice = new XMLHttpRequest();
            callApiGetNewDice(vNewDice, vXmlHttpDice)
            vXmlHttpDice.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {  //nếu trạng thái của response ready và ok
                    showData(vXmlHttpDice)
                }
            }
        }
    }
    function readData(paramDice) {
        var vUserName = document.getElementById("inp-username")
        var vFirstName = document.getElementById("inp-firstname")
        var vLastrName = document.getElementById("inp-lastname")
        paramDice.username = vUserName.value.trim();
        paramDice.firstname = vFirstName.value.trim();
        paramDice.lastname = vLastrName.value.trim();
    }
    function validateData(paramDice) {
        if (paramDice.username == "") {
            alert("Hãy nhập username !!!")
            return false
        }
        if (paramDice.firstname == "") {
            alert("Hãy nhập firstname !!!")
            return false
        }
        if (paramDice.lastname == "") {
            alert("Hãy nhập lastname !!!")
            return false
        }
        return true
    }
    function callApiGetNewDice(paramDice, paramXmlHttp) {
        var vResponse = JSON.stringify(paramDice)
        paramXmlHttp.open("POST", vBASE_URL + "/dice", true);
        paramXmlHttp.setRequestHeader("Content-Type", vUTF8_TEXT_APPLICATION_HEADER);
        paramXmlHttp.send(vResponse);  //chuyển Json object sang string
    }
    function showData(paramXmlHttp) {
        //hãy REFACTORING ĐẨY MÃ NGUỒN XỬ LÝ RA FUNCTION KHÁC
        console.log(paramXmlHttp.responseText);
        // parsing to object
        var vResponse = JSON.parse(paramXmlHttp.responseText);
        // get result dice
        var vDiceReady = vResponse.dice;
        console.log("dice result:= " + vDiceReady);
        changDice(vDiceReady);
        changNotification(vDiceReady);
        changVoucherId(vResponse);
        chanGift(vResponse);
    }
    function changDice(paramDice) {
        "use strict"
        var vImgDice = document.getElementById("img-dice")
        switch (paramDice) {
            case 1:
                vImgDice.src = "LuckyDiceImagesv2023Feb/1.png"
                break;
            case 2:
                vImgDice.src = "LuckyDiceImagesv2023Feb/2.png"
                break;
            case 3:
                vImgDice.src = "LuckyDiceImagesv2023Feb/3.png"
                break;
            case 4:
                vImgDice.src = "LuckyDiceImagesv2023Feb/4.png"
                break;
            case 5:
                vImgDice.src = "LuckyDiceImagesv2023Feb/5.png"
                break;
            default:
                vImgDice.src = "LuckyDiceImagesv2023Feb/6.png"
            // break;
        }
    }
    function changNotification(paramDice) {
        var vNotification = document.getElementById("p-dice")
        if (paramDice < 4) {
            vNotification.innerHTML = "Chúc bạn may mắn lần sau";
            vNotification.style.color = "red";
        } else {
            vNotification.innerHTML = "Chúc mừng bạn hãy chơi lần nữa nhé";
            vNotification.style.color = "red";
        }
    }
    function changVoucherId(paramDice) {
        var vVoucherId = document.getElementById("p-voucher");
        var vVoucherPercent = document.getElementById("p-%voucher")
        if (paramDice.voucher != null) {
            vVoucherId.innerHTML = paramDice.voucher.maVoucher;
            vVoucherPercent.innerHTML = paramDice.voucher.phanTramGiamGia + " %";
        } else {
            vVoucherId.innerHTML = "NO VOUCHER";
            vVoucherPercent.innerHTML = "0 %";
        }
    }
    function chanGift(paramDice) {
        var vPrize = document.getElementById("img-prize")
        var vPhanThuong = paramDice.prize
        switch (vPhanThuong) {
            case "Mũ":
                vPrize.src = "LuckyDiceImagesv2023Feb/hat.jpg"
                break;
            case "Áo":
                vPrize.src = "LuckyDiceImagesv2023Feb/t-shirt.jpg"
                break;
            case "Xe máy":
                vPrize.src = "LuckyDiceImagesv2023Feb/xe-may.jpg"
                break;
            case "Ô tô":
                vPrize.src = "LuckyDiceImagesv2023Feb/car.jpg"
                break;
            case "Bút":
                vPrize.src = "LuckyDiceImagesv2023Feb/but.jpg"
                break;
            case "Áo mưa":
                vPrize.src = "LuckyDiceImagesv2023Feb/ao-mua.jpg"
                break;
            case "Sổ":
                vPrize.src = "LuckyDiceImagesv2023Feb/book.jpg"
                break;
            default:
                vPrize.src = "LuckyDiceImagesv2023Feb/no-present.jpg"
                break;
        }
    }
    function callApiDiceHistory(paramDice, paramXmlHttp) {
        paramXmlHttp.open("GET", vBASE_URL + "/dice-history?username=" + paramDice.username, true);
        paramXmlHttp.send();
    }
    function showDatadiceHistory(paramXmlHttp) {
        var vResponse = JSON.parse(paramXmlHttp.responseText);
        var vTable = document.getElementById("history-placeholder-table");
        // var vTbody = document.getElementsByTagName("tbody")[0]

        vTable.innerHTML = ""
        // tạo header
        var vThead = document.createElement("thead");
        vTable.appendChild(vThead);
        var row = vThead.insertRow(0);
        var vLuotCell = document.createElement("th");
        var vDiceCell = document.createElement("th")
        vLuotCell.innerHTML = "Lượt #history-placeholder-table";
        vDiceCell.innerHTML = "Dice";
        row.appendChild(vLuotCell);
        row.appendChild(vDiceCell);

        // load data 

        var vTbody = document.createElement("tbody");
        debugger
        for (var bI = 0; bI < vResponse.dices.length; bI++) {
            var vNewRow = vTbody.insertRow(-1)
            var bGameCell = vNewRow.insertCell(0);
            var bDiceCell = vNewRow.insertCell(1);
            bGameCell.innerHTML = bI + 1
            bDiceCell.innerHTML = vResponse.dices[bI];
            vTable.appendChild(vTbody)

        }
    }
</script>

</html>